/**
	$Id: ReporterProxy.java 4478 2008-09-05 15:15:54Z jari $

	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.clients.migrate;

import net.sf.basedb.core.data.ReporterData;

/**

	This is a proxys for the ReporterData class, which only contains the
	ID. This class is needed to minimize the memory usage of the migration, 
	since we really don't need to keep all extended properties of the reporter
	once the reporters has been migrated.

	@author nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:15:54 +0200 (Fri, 05 Sep 2008) $
*/
public class ReporterProxy
	extends ReporterData
{
	
	private final int id;

	ReporterProxy(int id)
	{
		this.id = id;
	}
	
	ReporterProxy(ReporterData reporter)
	{
		this.id = reporter.getId();
	}

	public int getId()
	{
		return id;
	}
}
