/**
	$Id: StopServiceRenderer.java 4478 2008-09-05 15:15:54Z jari $

	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.clients.web.extensions.service;

import net.sf.basedb.util.extensions.Renderer;

/**
	A renderer that stops the the service of a
	{@link ServiceControllerAction}.

	@author nicklas
	@version 2.8
	@base.modified $Date: 2008-09-05 17:15:54 +0200 (Fri, 05 Sep 2008) $
 */
public class StopServiceRenderer
	implements Renderer<ServiceControllerAction>
{

	private static final org.apache.log4j.Logger log = 
		org.apache.log4j.LogManager.getLogger("net.sf.basedb.clients.web.extensions.service.StopServiceRenderer");

	public StopServiceRenderer()
	{}
	
	/**
		Calls {@link ServiceControllerAction#stop()} on the <code>service</code>.
	*/
	@Override
	public void render(ServiceControllerAction service)
	{
		log.info("Stopping service: " + service);
		service.stop();
		log.info("Stopping service done: " + service);
	}

}
