/*
	$Id: StartStopServlet.java 4478 2008-09-05 15:15:54Z jari $

	Copyright (C) Nicklas Nordborg
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.clients.web.servlet;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import net.sf.basedb.core.Application;

/**
	Servlet for starting BASE when the web server is started and
	stopping BASE when the web server is stopped. This servlet is very simple.
	It will call {@link Application#start()} when it is loaded and
	{@link Application#stop()} when it is destroyed.
	<p>
	
	This servlet should be configured to load before any other servlet that
	use BASE classes.
	
	@author nicklas
	@version 2.8
	@base.modified $Date: 2008-09-05 17:15:54 +0200 (Fri, 05 Sep 2008) $
*/
public class StartStopServlet 
	extends HttpServlet
{
	
	private static final long serialVersionUID = 8267932757094628788L;

	public StartStopServlet()
	{}
	
	/**
		Calls {@link Application#start()}.
	*/
	@Override
	public void init()
		throws ServletException
	{
		super.init();
		Application.start();
	}

	/**
		Calls {@link Application#stop()}.
	*/
	@Override
	public void destroy()
	{
		Application.stop();
		super.destroy();
	}

}
