/*
	$Id: ProgressReporter.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005 Samuel Andersson, Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core;

/**

	Certain methods in BASE can report their progress back to
	the calling client application if they are giving an object
	that implements this interface.

	@author Nicklas
	@version 2.0
*/
public interface ProgressReporter
{
	/**
		Display a progress message.
		@param percent How many percent of the task that is completed
		@param message A message, or null
	*/
	public void display(int percent, String message);

	/**
		Append a message to the previous one.
		@param message The message
	*/
	public void append(String message);
}
