/*
	$Id: Validatable.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005, 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core;

/**
	This interface is a tagging interface for items that needs case 2
	validation. See <a 
	href="../../../../../development/overview/core/datavalidation,html">Core API overview - 
	Data validation</a> and <a 
	href="../../../../../development/coding/item/index.html#validation">Coding rules and 
	guidelines for item classes</a>
	<p>
	By implementing this interface an item tells the <code>DbControl</code>
	to call the {@link BasicItem#validate()} whenever commit is called.
	<p>

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
*/
public interface Validatable
	extends Controlled
{}
