/*
	$Id: DataCubeColumnData.java 4479 2008-09-05 15:16:27Z jari $
	
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/
	
	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.
	
	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core.data;

/**
	This class holds information about a single column in a data cube.
	
	@author Nicklas
	@version 2.0
	@see net.sf.basedb.core.DataCubeColumn
	@see <a href="../../../../../../html/developerdoc/api/data_api.experiments.html">Experiments and analysis overview</a>
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
	@hibernate.class table="`DataCubeColumns`" lazy="true"
*/
public class DataCubeColumnData
	extends BasicData
{
	public DataCubeColumnData()
	{}

	private DataCubeData dataCube;
	/**
		Get the data cube this column belongs to.
		@hibernate.many-to-one column="`datacube_id`" not-null="true" outer-join="false" 
			update="false" unique-key="uniquecolumn" cascade="save-update"
	*/
	public DataCubeData getDataCube()
	{
		return dataCube;
	}
	public void setDataCube(DataCubeData dataCube)
	{
		this.dataCube = dataCube;
	}

	private short columnNo;
	/**
		The column number of this column in the data cube.
		@hibernate.property column="`column_no`" type="short" not-null="true" update="false" 
			unique-key="uniquecolumn"
	*/
	public short getColumnNo()
	{
		return columnNo;
	}
	public void setColumnNo(short columnNo)
	{
		this.columnNo = columnNo;
	}
	
}
