/*
	$Id: ProjectKeyData.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2005, 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core.data;

import java.util.Map;
import java.util.HashMap;

/**
	This class holds information access privileges for projects.

	@author Nicklas
	@version 2.0
	@see net.sf.basedb.core.ProjectKey
	@see <a href="../../../../../../html/developerdoc/api/data_api.authentication.html">Authentication overview</a>
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
	@hibernate.subclass discriminator-value="2"
*/
public class ProjectKeyData
	extends KeyData
{

	public ProjectKeyData()
	{}

	private Map<ProjectData,Integer> projects;
	/**
		Get the map that manages which projects that have permissions 
		for this key.

		@hibernate.map table="`ProjectKeys`" lazy="true"
		@hibernate.collection-key column="`key_id`"
		@hibernate.index-many-to-many column="`project_id`" class="net.sf.basedb.core.data.ProjectData"
		@hibernate.collection-element column="`permission`" type="int" not-null="true"
	*/
	public Map<ProjectData,Integer> getProjects()
	{
		if (projects == null) projects = new HashMap<ProjectData,Integer>();
		return projects;
	}
	void setProjects(Map<ProjectData,Integer> projects)
	{
		this.projects = projects;
	}
}
