/*
	$Id: SchemaVersionData.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.core.data;

/**
	This class holds information about the current schema version of the database.
	It contains only one record. All modifications to the database which requires some
	update script action on the data bumps the version number with one.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
	@hibernate.class table="`SchemaVersion`" lazy="false"
*/
public class SchemaVersionData
	extends BasicData
{

	public SchemaVersionData()
	{}
	
	private int schemaVersion;
	/**
		The current schema version.
		@hibernate.property column="`schema_version`" type="int" not-null="true"
	*/
	public int getSchemaVersion()
	{
		return schemaVersion;
	}
	public void setSchemaVersion(int schemaVersion)
	{
		this.schemaVersion = schemaVersion;
	}
	
	private int build;
	/**
		The build number.
		@hibernate.property column="`build`" type="int" not-null="true"
	*/
	public int getBuild()
	{
		return build;
	}
	public void setBuild(int build)
	{
		this.build = build;
	}
}
