/**
	$Id: ConfigureByExample.java 4479 2008-09-05 15:16:27Z jari $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
*/
package net.sf.basedb.util.parser;

import net.sf.basedb.core.plugin.Plugin;

/**
 	This is a tagging interface for all plugins that use
 	the {@link FlatFileParser} and wants easier configuration
 	of the regular expressions used to parse the file.
 	<p>
 	The web interface checks for plugins that implements this interface
 	and create a "Test with file" button if the 
 	{@link net.sf.basedb.plugins.AbstractFlatFileImporter#parserSection} parameter is present.
 	The web interface expects plugin parameters for the regular expressions as defined by the 
 	{@link net.sf.basedb.plugins.AbstractFlatFileImporter} class. Parameters for
 	columns mappings must have the string "Mapping" in the parameter name. For
 	example <code>reporterIdColumnMapping</code>, <code>extendedColumnMapping.species</code>
 	and <code>propertyMapping.ch1FgMedian</code>.
 	<p>
 	All core plugins follow these directions.

	@author nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:16:27 +0200 (Fri, 05 Sep 2008) $
	@see net.sf.basedb.plugins.ReporterFlatFileImporter
*/
public interface ConfigureByExample
	extends Plugin
{}
