/**
	$Id: Run.java 4480 2008-09-05 15:16:58Z jari $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA. 
*/
package net.sf.basedb.test.merge;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import net.sf.basedb.test.TestUtil;

/**

	@author nicklas
	@version 2.0
	@base.modified $Date: 2008-09-05 17:16:58 +0200 (Fri, 05 Sep 2008) $
*/
public class Run
{

	public static void main(String[] args)
	{
		
		Set<String> cmds = new HashSet<String>(Arrays.asList(args));
		boolean all = cmds.contains("all");
		boolean logMemoryUsage = cmds.contains("-m");
		
		int tests = 0;
		boolean ok = true;
		if (ok && (all || cmds.contains("setup")))
		{
			TestUtil.begin(logMemoryUsage, false);
			ok = MergeTest.run();
			tests++;
		}
		TestUtil.stop();
		
		if (tests == 0)
		{
			showUsage();
		}
	}
	
	
	public static void showUsage()
	{
		TestUtil.write(
			"test.sh merge [-m] <cmds>\n" + 
			"     -m = log memory usage to file memory.log\n" +
			"     cmds = list of tests to run; all, setup\n\n");
	}
	
}
