<%-- $Id: index.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Enumeration"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = request.getParameter("subcontext");
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";

String forward = null;
String redirect = null;
String message = null;

if ("SaveCurrentContext".equals(cmd))
{
	String name = Values.getStringOrNull(request.getParameter("name"));
	boolean overwrite = Values.getBoolean(request.getParameter("overwrite"));
	boolean isPublic = Values.getBoolean(request.getParameter("public"));
	sc.saveCurrentContextAs(itemType, subContext, name, overwrite, isPublic);
	message = "Preset saved";
}
else if ("DeleteContext".equals(cmd))
{
	int contextId = Values.getInt(request.getParameter("context_id"));
	sc.deleteContext(contextId);
	redirect = "manage.jsp?ID=" + ID + "&item_type="+itemType.name()+"&subcontext="+subContext;
}
else if ("DeleteContexts".equals(cmd))
{
	int numRemoved = 0;
	int numTotal = 0;
	Enumeration<String> names = request.getParameterNames();
	while (names.hasMoreElements())
	{
		int id = Values.getInt(names.nextElement(), -1);
		if (id != -1)
		{
			try
			{
				numTotal++;
				sc.deleteContext(id);
				numRemoved++;
			}
			catch (PermissionDeniedException ex)
			{}
		}
	}
	if (numTotal != numRemoved)
	{
		message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
	}
	redirect = "manage.jsp?ID=" + ID + "&item_type="+itemType.name()+"&subcontext="+subContext+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");;
}
else if ("LoadContext".equals(cmd))
{
	final ItemContext current = sc.getCurrentContext(itemType, subContext);
	int contextId = Values.getInt(request.getParameter("context_id"));
	ItemContext newContext = sc.loadContext(contextId);
	if (current != null && newContext != null)
	{
		// Copy list of default columns so it is available in the loaded context
		newContext.setObject("defaultColumns", current.getObject("defaultColumns"));
	}
	message = "Preset loaded";
}
else
{
	throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>
