<%-- $Id: parse_file.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	contentType="text/html; charset=UTF-8"	
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.parser.FlatFileParser"
	import="net.sf.basedb.util.parser.WrappedConfigureByExample"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.fuzzy.StringMatcher"
	import="net.sf.basedb.util.fuzzy.StringMatcher.FuzzyMatch"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.regex.Pattern"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Set"
	import="java.io.InputStream"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
request.setCharacterEncoding("UTF-8");
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
final float scale = Base.getScale(sc);
InputStream fileInputStream = null;
try
{
	String path = request.getParameter("path");
	String charsetName = Values.getString(request.getParameter("charset"), Config.getCharset());
	PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	Plugin plugin = pcRequest.getPlugin();
	
	File file = null;
	FlatFileParser parser = null;
	FlatFileParser.LineType lastLine = null;
	Pattern splitter = null;
	boolean dataIsFound = false;
	int maxLines = Values.getInt(request.getParameter("maxLines"), FlatFileParser.DEFAULT_MAX_UNKNOWN_LINES);
	
	List<String> messages = new ArrayList<String>();
	
	if (path != null)
	{
		Path p = new Path(path, Path.Type.FILE);
		file = File.getByPath(dc, p, false);
		parser = new FlatFileParser();
		parser.setMaxUnknownLines(maxLines);
		
		String header = Values.getStringOrNull(request.getParameter("header"));
		if (header != null)
		{
			try
			{
				parser.setHeaderRegexp(Pattern.compile(header));
			}
			catch (Throwable t)
			{
				messages.add("Invalid regular expression for header: " + HTML.encodeTags(header));
			}
		}
		
		String dataSplitter = Values.getStringOrNull(request.getParameter("dataSplitter"));
		if (dataSplitter != null)
		{
			try
			{
				splitter = Pattern.compile(dataSplitter);
				parser.setDataSplitterRegexp(splitter);
			}
			catch (Throwable t)
			{
				messages.add("Invalid regular expression for data splitter: " + HTML.encodeTags(dataSplitter));
			}
		}

		String dataHeader = Values.getStringOrNull(request.getParameter("dataHeader"));
		if (dataHeader != null)
		{
			try
			{
				parser.setDataHeaderRegexp(Pattern.compile(dataHeader));
			}
			catch (Throwable t)
			{
				messages.add("Invalid regular expression for data header: " + HTML.encodeTags(dataHeader));
			}
		}
		
		String dataFooter = Values.getStringOrNull(request.getParameter("dataFooter"));
		if (dataFooter != null)
		{
			try
			{
				parser.setDataFooterRegexp(Pattern.compile(dataFooter));
			}
			catch (Throwable t)
			{
				messages.add("Invalid regular expression for data footer: " + HTML.encodeTags(dataFooter));
			}
		}
		
		String ignore = Values.getStringOrNull(request.getParameter("ignore"));
		if (ignore != null)
		{
			try
			{
				parser.setIgnoreRegexp(Pattern.compile(ignore));
			}
			catch (Throwable t)
			{
				messages.add("Invalid regular expression for ignore: " + HTML.encodeTags(ignore));
			}
		}

		parser.setTrimQuotes(Values.getBoolean(request.getParameter("trimQuotes")));
		parser.setMinDataColumns(Values.getInt(request.getParameter("minDataColumns"), 0));
		parser.setMaxDataColumns(Values.getInt(request.getParameter("maxDataColumns"), -1));
		
		fileInputStream = file.getDownloadStream(0);
		if (plugin instanceof WrappedConfigureByExample)
		{
			WrappedConfigureByExample wex = (WrappedConfigureByExample)plugin;
			fileInputStream = wex.wrapInputStream(fileInputStream);
		}
		parser.setInputStream(fileInputStream, charsetName);
		lastLine = parser.parseHeaders();
		dataIsFound = lastLine == FlatFileParser.LineType.DATA || lastLine == FlatFileParser.LineType.DATA_HEADER;
		if (!dataIsFound)
		{
			messages.add("Start of data couldn't be found. Please try again with different settings.");
		}
	}
	%>
	<base:page type="popup" title="Test with file">
	<base:head scripts="tabcontrol.js" styles="table.css,tabcontrol.css">
		<script language="JavaScript">
		var patterns = new Array();
		var columnHeaders = new Array();
		function setPattern(list, patternIndex)
		{
			var whatPattern = list[list.selectedIndex].value;
			list.selectedIndex = 0;
			var frm = window.parent.document.forms['testwithfile'];
			if (frm[whatPattern])
			{
				frm[whatPattern].value = patterns[patternIndex];
			}
		}
		function setColumnMapping(list, mappingName, expression, overwrite)
		{
			var frm = document.forms['mappings'];
			var field = 'mapping.'+mappingName+'.expression';
			if (list)
			{
				var colIndex = list[list.selectedIndex].value;
				expression = columnHeaders.length > 0 ? columnHeaders[colIndex] : '\\';
				list.selectedIndex = 0;
				var style = Forms.getCheckedRadio(frm.expressionStyle);
				var existing = overwrite ? '' : frm[field].value;
				if (style && style.value == 1)
				{
					if (expression.indexOf('\\') >= 0) expression = colIndex;
					expression = existing+'\\'+expression+'\\';
				}
				else
				{
					if (expression.indexOf('\\') >= 0)
					{
						expression = 'col('+colIndex+')';
					}
					else
					{
						expression = 'col(\''+expression+'\')';
					}
					if (existing)
					{
						expression = existing + '+' + expression;
					}
					else
					{
						expression = '=' + expression;
					}
				}
			}
			
			frm[field].value = expression;
			window.parent.setFormValue(field, expression);
		}

		var fuzzyMatches = new Array();
		function setFuzzyMatches()
		{
			var frm = document.forms['mappings'];
			var minScore = parseFloat(frm.similarity.value);
			for (var i = 0; i < fuzzyMatches.length; i++)
			{
				var match = fuzzyMatches[i];
				if (match)
				{
					if (match.score >= minScore)
					{
						var list = frm['list.' + match.name];
						list.selectedIndex = 1 + match.fileColIndex;
						setColumnMapping(list, match.name, '', true);
					}
					else
					{
						setColumnMapping(null, match.name, '', true);
					}
				}
			}
		}
		</script>
	</base:head>
	<base:body onload="window.parent.adjustIFrameSize()">
	<t:tabcontrol id="parsedFile" 
		contentstyle="<%="height: "+(int)(scale*400)+"px;"%>" autoheight="false">
	<t:tab
		id="filedata"
		title="File data"
		>
		<%
		if (file == null)
		{
			%>
			<br><br>
			<div align="center">
			<div class="error" style="width: 50%; font-size: larger; font-weight: bold;">
				<br>
				No file selected. Please select a file to test above.
				<br><br>
			</div>
			</div>
			<%
		}
		else
		{
			if (messages.size() > 0)
			{
				%>
				<div class="error">
				<table align="center"><tr><td>
				<b>Could not parse the file <code><%=HTML.encodeTags(path)%></code></b>
				<ol>
				<li><%=Values.getString(messages, "<li>", true)%>
				</ol>
				</td></tr></table>
				</div>
				<%
			}
			%>
			<table class="itemlist" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td class="data">
				<table border="0" cellspacing="0" cellpadding="0">
				
				<tr>
					<th class="columnheader">Line</th>
					<th class="columnheader">Columns</th>
					<th class="columnheader">Type</th>
					<th class="columnheader">Use as</th>
					<th class="columnheader" colspan="99">File data</th>
				</tr>
			
				<%
				int currentLine = 0;
				int headerLines = parser.getLineCount();
				String[] rowclass = new String[] { "oddrow", "evenrow" };
				int rowClassIndex = 0;
				List<String> patterns = new ArrayList<String>(maxLines);
				while (currentLine <= maxLines && currentLine < headerLines)
				{
					FlatFileParser.Line line = parser.getLine(currentLine);
					patterns.add(HTML.javaScriptEncode(Pattern.quote(line.line())));
					String[] data = null;
					if (line.type() == FlatFileParser.LineType.HEADER)
					{
						data = new String[] { line.name(), line.value() };
					}
					else if (splitter != null)
					{
						data = parser.trimQuotes(splitter.split(line.line(), 99));
					}
					else
					{
						data = new String[] { line.line() };
					}
					%>
					<tr class="<%=rowclass[rowClassIndex]%>">
						<td class="cell"><%=line.lineNo()%></td>
						<td class="cell"><%=data.length%></td>
						<td class="cell"><%=line.type()%></td>
						<td class="cell">
							<select onchange="setPattern(this, <%=currentLine%>)">
							<option value="">
							<option value="dataHeader">Data header
							<option value="dataFooter">Data footer
							</select>
						</td>
						<%
						for (String d : data)
						{
							%>
							<td class="cell"><%=HTML.encodeTags(d) %></td>
							<%
						}
						%>
					</tr>
					<%
					currentLine++;
					rowClassIndex = 1 - rowClassIndex;
				}
				if (currentLine < maxLines)
				{
					if (lastLine == FlatFileParser.LineType.DATA) parser.nextData();
					while (currentLine <= maxLines && parser.hasMoreData())
					{
						FlatFileParser.Data data = parser.nextData();
						patterns.add(HTML.javaScriptEncode(Pattern.quote(data.line())));
						if (parser.getNumSkippedLines() > 0)
						{
							%>
							<tr>
								<td class="error" colspan="99">
								Skipped <%=parser.getNumSkippedLines()%> lines 
								(<%=parser.getIgnoredLines()%> ignored; <%=parser.getUnknownLines()%> unknown)
								</td>
							</tr>
							<%
						}
						%>
						<tr class="<%=rowclass[rowClassIndex]%>">
							<td class="cell"><%=data.lineNo()%></td>
							<td class="cell"><%=data.columns()%></td>
							<td class="cell">Data</td>
							<td class="cell">
								<select onchange="setPattern(this, <%=currentLine%>)">
								<option value="">
								<option value="dataHeader">Data header
								<option value="dataFooter">Data footer
								</select>
							</td>
							<%
							for (int i = 0; i < data.columns(); ++i)
							{
								%>
								<td class="cell"><%=HTML.encodeTags(data.get(i))%></td>
								<%
							}
							%>
						</tr>
						<%
						currentLine++;
						rowClassIndex = 1 - rowClassIndex;
					}
					if (parser.getNumSkippedLines() > 0)
					{
						%>
						<tr>
							<td class="error" colspan="99">
							Skipped <%=parser.getNumSkippedLines()%> lines 
							(<%=parser.getIgnoredLines()%> ignored; <%=parser.getUnknownLines()%> unknown)
							</td>
						</tr>
						<%
					}
				}
				%>
				<script language="JavaScript">
				<%
				for (String pattern : patterns)
				{
					%>
					patterns[patterns.length] = '<%=pattern%>';
					<%
				}
				if (parser.getColumnHeaders() != null)
				{
					for (String columnHeader : parser.getColumnHeaders())
					{
						%>
						columnHeaders[columnHeaders.length] = '<%=HTML.javaScriptEncode(columnHeader)%>';
						<%
					}
				}
				%>
				</script>
				</table>
				</td>
			</tr>
			</table>
			<%
		}
		%>
		</t:tab>

		<t:tab
			id="mappings"
			title="Column mappings"
			visible="<%=dataIsFound && request.getParameter("mappingParameterNames") != null%>"
			>
			<%
			StringBuilder sb = new StringBuilder();
			List<String> headers = parser.getColumnHeaders();
			int index = 0;
			if (headers != null)
			{
				for (String header : headers)
				{
					sb.append("<option value=\"" + index + "\">" + HTML.encodeTags(header));
					index++;
				}
			}
			else
			{
				int maxDataColumns = Values.getInt(request.getParameter("maxDataColumns"), -1);
				while (index < maxDataColumns)
				{
					sb.append("<option value=\"" + index + "\">" + index);
					index++;
				}
			}
			String mappings = sb.toString();
			String[] mappingParameters = request.getParameter("mappingParameterNames").split(",");
			List<String> labels = new ArrayList<String>();
			for (String name : mappingParameters)
			{
				labels.add(request.getParameter("mapping." + name + ".label"));
			}
			StringMatcher sm = new StringMatcher();
			List<FuzzyMatch> matches = headers == null ? null : sm.getBestPairs(labels, headers);
			%>
			<script language="JavaScript">
			<%
			if (matches != null)
			{
				int i = 0;
				for (FuzzyMatch fm : matches)
				{
					String name = mappingParameters[i];
					if (fm != null)
					{
						%>
						fuzzyMatches[<%=i%>] = { name:'<%=name%>', fileColIndex:<%=headers.indexOf(fm.getValue())%>, score:<%=fm.getScore()%> };	
						<%
					}
					else
					{
						%>
						fuzzyMatches[<%=i%>] = null;
						<%
					}
					++i;
				}
			}
			%>
			</script>
			<form name="mappings">
			<table>
			<tr>
			<td>
			<b>Mapping style:</b>
			<input type="radio" name="expressionStyle" value="1" checked>Simple
			<input type="radio" name="expressionStyle" value="2">Expression
			</td>
			<%
			if (matches != null)
			{
				%>
				<td>
				<base:button onclick="setFuzzyMatches()" title="Auto generate" 
					tooltip="Generate mappings by finding the best match between Property and File column"/>
				</td>
				<td>
					Similarity score: <input type="text" 
					name="similarity" value="0.85" onkeypress="return Numbers.numberOnly(event)">
					(0 = bad; 1 = good)
				</td>
				<%
			}
			%>
			</tr>
			</table>

			<table class="itemlist" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td class="data">
				<table border="0" cellspacing="0" cellpadding="0">
				<tr>
					<th class="columnheader">Property</th>
					<th class="columnheader">Mapping expression</th>
					<th class="columnheader">File columns</th>
				</tr>
				<%
				for (String name : mappingParameters)
				{
					%>
					<tr>
						<td class="cell"><%=HTML.encodeTags(request.getParameter("mapping." + name + ".label"))%></td>
						<td class="cell">
							<input type="text" class="text" name="mapping.<%=name%>.expression"
								size="40" maxlength="80" 
								value="<%=HTML.encodeTags(request.getParameter("mapping." + name + ".expression"))%>"
								onblur="setColumnMapping(null, '<%=name%>', this.value)">
								
								<base:icon image="cancel.gif" 
									onclick="<%="setColumnMapping(null, '" + name + "', '')"%>" 
									tooltip="Clear this expression"/>
						</td>
						<td class="cell">
							<select name="list.<%=name%>" onchange="setColumnMapping(this, '<%=name%>')">
							<option value="">
							<%=mappings%>
							</select>
						</td>
					</tr>
					<%
				}
				%>
				</table>
				</td>
			</tr>
			</table>
			</form>
		</t:tab>
			
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (fileInputStream != null) fileInputStream.close();
	if (dc != null) dc.close();
}
%>

