<%-- $Id: switch.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final String login = Values.getString(request.getParameter("login"), "");
final String error = Values.getString(request.getParameter("error"), null);
final String root = request.getContextPath()+"/";

final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	%>
	<base:page type="popup" title="Switch user">
	<base:head scripts="md5.js" styles="login.css">
		<script language="JavaScript" type="text/javascript">
		// Set foucs on the login form
		function init()
		{
			setFocus();
		}
		
		// Set the focus on either the login or password field.
		function setFocus()
		{
			frm = document.forms['login'];
			if (frm.login.value == '' && window.parent.lastLogin) frm.login.value = window.parent.lastLogin;
			if (frm.encrypt && window.parent.encrypt != undefined) frm.encrypt.checked = window.parent.encrypt;
			if (frm.login.value == '')
			{
				frm.login.focus();
			}
			else
			{
				frm.password.focus();
				frm.password.select();
			}
		}
		function saveLogin()
		{
			var frm = document.forms['login'];
			window.opener.parent.lastLogin = frm.login.value;
			
			if (frm.encrypt)
			{
				window.opener.parent.encrypt = frm.encrypt.checked;
				if (frm.encrypt.checked)
				{
					var password = frm.password.value;
					var md5password = hex_md5(password);
					md5password = hex_md5(md5password + ':<%=sc.getChallenge()%>');
					frm.encrypted_password.value = md5password;
					frm.password.value = '';
				}
			}
			return true;
		}
		function doLogin()
		{
			saveLogin();
			var frm = document.forms['login'];
			if (frm.remainOnPage.checked) 
			{
				frm.redirect.value = '';
			}
			else
			{
				frm.redirect.value = '<%=root%>my_base/index.jsp?ID=<%=ID%>';
			}
			frm.submit();
		}
		</script>
	</base:head>
	
	<base:body onload="init();">
		<form name="login" action="login.jsp" method="post" onsubmit="doLogin();">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="again" value="1">
		<input type="hidden" name="redirect" value="">
		<input type="hidden" name="encrypted_password" value="">
	
		<h3 class="docked">Switch user <base:help helpid="switchuser" /></h3>
		<div class="boxedbottom">
			<%
			if (error != null) 
			{
				%>
				<div class="error"><%=error%></div>
				<%
			}
			%>

			<table class="form" border="0" cellspacing="1" cellpadding="2">
			<tr>
				<td class="prompt">Login</td>
				<td><input class="text" type="text" name="login" value="<%=HTML.encodeTags(login)%>" 
					size="15" maxlength="100"
					style="width: 120px"></td>
			</tr>
			<tr>
				<td class="prompt">Password</td>
				<td>
					<input class="text" type="password" name="password" size="15" maxlength="80"
						onkeypress="return Forms.submitOnEnter(event, saveLogin)"
						style="width: 120px">
				</td>
			</tr>
			<%
			if (Application.isUsingInternalAuthentication())
			{
				%>
				<tr>
					<td class="prompt">Encrypt password</td>
					<td>
						<input type="checkbox" name="encrypt" checked value="1">
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">Remain on this page</td>
				<td>
					<input type="checkbox" name="remainOnPage" checked value="1">
				</td>
			</tr>
			</table>
		</div>
		
		<br>
		<table align="center">
		<tr>
			<td width="50%"><base:button image="login.png" onclick="doLogin();" title="Login" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
		

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

