<%-- $Id: view_reporterlist.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/
	
	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.
	
	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA. 
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.REPORTERLIST;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final ReporterList reporterList = ReporterList.getById(dc, itemId);
	
	final boolean writePermission = reporterList.hasPermission(Permission.WRITE);
	final boolean deletePermission = reporterList.hasPermission(Permission.DELETE);
	final boolean sharePermission = reporterList.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = reporterList.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = reporterList.isRemoved();
	final boolean isUsed = isRemoved && reporterList.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = reporterList.isOwner();
	%>
	<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="toolbar.css,headertabcontrol.css,path.css,table.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareReporterList', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function takeOwnership()
		{
			if (confirm('Are you sure that you want to take ownership of this item? It can\'t be undone.'))
			{
				location.replace('index.jsp?ID=<%=ID%>&cmd=TakeOwnershipOfItem&item_id=<%=itemId%>');
			}
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function viewReporters()
		{
			location.href = 'reporters/index.jsp?ID=<%=ID%>&cmd=List&reporterlist_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'reporters')
			{
				viewReporters();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function merge(mergeType)
		{
			Main.openPopup('merge.jsp?ID=<%=ID%>&item_id=<%=itemId%>&mergeType='+mergeType, 'Union', 600, 440);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Reporter lists" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(reporterList.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties" switch="switchTab">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this reporter list" : "You do not have permission to edit this reporter list"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!reporterList.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this reporter list" : "You do not have permission to delete this reporter list"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=reporterList.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this reporter list" : "You do not have permission to restore this reporter list"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this reporter list to other user, groups and projects" : "You do not have permission to share this formula"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="takeOwnership()" 
				title="Take ownership&hellip;"
				visible="<%=!isOwner%>"
				tooltip="<%=setOwnerPermission ? "Take ownership of this item" : "You do not have permission to take ownership of this item"%>"
			/>
			<tbl:button
				visible="<%=writePermission%>"
				image="set_operations/union_small.png"
				onclick="merge('union')"
				title="Union&hellip;"
				tooltip="Add reporters from other lists to this list"
			/>
			<tbl:button
				visible="<%=writePermission%>"
				image="set_operations/intersection_small.png"
				onclick="merge('intersection')"
				title="Intersection&hellip;"
				tooltip="Keep only reporters that are present in other lists"
			/>
			<tbl:button
				visible="<%=writePermission%>"
				image="set_operations/complement_small.png"
				onclick="merge('complement')"
				title="Complement&hellip;"
				tooltip="Remove reporters in other lists from this list"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'reporterlist.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(reporterList)%></i></div>
			<%
			if (reporterList.isRemoved() || reporterList.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=reporterList.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(reporterList.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><%=HTML.encodeTags(reporterList.getExternalId())%></td>
			</tr>
			<tr>
				<td class="prompt">Size</td>
				<td><%=reporterList.getSize()%></td>
			</tr>
			<tr>
				<td class="prompt">Experiment</td>
				<td><base:propertyvalue item="<%=reporterList%>" property="experiment" /></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=reporterList%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(reporterList.getDescription())%></td>
			</tr>
			</table>
			<%			
			
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(reporterList));
			ItemResultIterator<User> users = mp.getUsers().iterate(dc);
			ItemResultIterator<Group> groups = mp.getGroups().iterate(dc);
			ItemResultIterator<Project> projects = mp.getProjects().iterate(dc);
			
			if (users.hasNext() || groups.hasNext() || projects.hasNext())
			{
				%>
				<h4 class="docked">Shared to</h4>
				<tbl:table 
					id="itemsSharedTo"
					clazz="itemlist"
					columns="all"
				>
					<tbl:columndef 
						id="itemType"
						title="Item type"
					/>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="permissions"
						title="Permissions"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						while(projects.hasNext())
						{
							Project project = projects.next();
							Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
							%>			
							<tbl:row>
								<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=project.isRemoved()%>"
								/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						while(groups.hasNext())
						{
							Group group = groups.next();
							Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=group.isRemoved()%>"
								/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%	
						}
						while (users.hasNext())
						{
							User user = users.next();
							Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=user.isRemoved()%>"
								/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This reporter list is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>

		</div>
		</t:tab>
		
		<t:tab id="reporters" title="Reporters" 
			tooltip="List the reporters in this reporter list" />
		
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
